[type/__package_pkg_openbsd] Clean up code

This commit is contained in:
Takashi Yoshi 2018-12-14 12:35:04 +01:00
parent 498628d16a
commit aa456ab6c1
1 changed files with 74 additions and 76 deletions

View File

@ -23,100 +23,98 @@
# Manage packages with pkg on OpenBSD # Manage packages with pkg on OpenBSD
# #
# Debug os_version=$(cat "${__global}/explorer/os_version")
# exec >&2 machine=$(cat "${__global}/explorer/machine")
# set -x
os_version="$(cat "$__global/explorer/os_version")" if [ -f "${__object}/parameter/version" ]; then
machine="$(cat "$__global/explorer/machine")" version=$(cat "${__object}/parameter/version")
if [ -f "$__object/parameter/version" ]; then
version="$(cat "$__object/parameter/version")"
fi fi
if [ -f "$__object/parameter/flavor" ]; then if [ -f "${__object}/parameter/flavor" ]; then
flavor="$(cat "$__object/parameter/flavor")" flavor=$(cat "${__object}/parameter/flavor")
fi fi
# do not show progress bar # Do not show progress bar
pkgopts="-x" pkgopts='-x'
if [ -f "$__object/parameter/name" ]; then name="${__object_id}"
name=$(cat "$__object/parameter/name") if [ -f "${__object}/parameter/name" ]; then
name=$(cat "${__object}/parameter/name")
fi
if [ -n "${version}" ] && [ -n "${flavor}" ]; then
pkgid="${name}-${version}-${flavor}"
elif [ -n "${version}" ]; then
pkgid="${name}-${version}"
elif [ -f "${__object}/parameter/flavor" ]; then
pkgid="${name}--${flavor}"
else else
name="$__object_id" pkgid="${name}"
fi fi
if [ -n "$version" ] && [ -n "$flavor" ]; then state_should=$(cat "${__object}/parameter/state")
pkgid="$name-$version-$flavor"
elif [ -n "$version" ]; then
pkgid="$name-$version"
elif [ -n "$flavor" ]; then
pkgid="$name--$flavor"
elif [ -f "$__object/parameter/flavor" ]; then
pkgid="$name--"
else
pkgid="$name"
fi
state_should="$(cat "$__object/parameter/state")" pkg_version=$(cat "${__object}/explorer/pkg_version")
pkg_version="$(cat "$__object/explorer/pkg_version")" if [ -f "${__object}/parameter/pkg_path" ]; then
pkg_path=$(cat "${__object}/parameter/pkg_path")
if [ -f "$__object/parameter/pkg_path" ]; then
pkg_path="$(cat "$__object/parameter/pkg_path")"
else else
has_installurl=$(cat "${__object}/explorer/has_installurl") has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ Xyes != X"${has_installurl}" ]; then if [ 'yes' != "${has_installurl}" ]; then
# there is no default PKG_PATH, try to provide one # There is no default PKG_PATH, try to provide one
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/$os_version/packages/$machine/" pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/${os_version}/packages/${machine}/"
fi fi
fi fi
state_is="$(cat "$__object/explorer/pkg_state")" state_is=$(cat "${__object}/explorer/pkg_state")
[ "$state_is" = "$state_should" ] && exit 0 [ "${state_is}" = "${state_should}" ] && exit 0
case "$state_should" in case "${state_should}" in
present) present)
# use this because pkg_add doesn't properly handle errors if [ -n "${pkg_path}" ]; then
cat << eof echo "export PKG_PATH='${pkg_path}'"
if [ X != X"${pkg_path}" ]; then
PKG_PATH="${pkg_path}"; export PKG_PATH
fi
status=\$(pkg_add "$pkgopts" "$pkgid" 2>&1)
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}$" 2>/dev/null
# We didn't find the package in the list of 'installed packages', so it failed
# This is necessary because pkg_add doesn't return properly
if [ \$? -ne 0 ]; then
if [ -z "\${status}" ]; then
status="Failed to add package, uncaught exception."
fi fi
echo "Error: \$status" >&2
# Use this because pkg_add doesn't properly handle errors
cat << EOF
status=\$(pkg_add ${pkgopts} '${pkgid}' 2>&1 || true)
if ! pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}$' 2>/dev/null
then
# We didn't find the package in the list of 'installed packages', so it failed.
# This is necessary because pkg_add doesn't return properly
if [ -z "\${status}" ]; then
status='Failed to add package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1 exit 1
fi fi
eof EOF
echo 'installed' >> "${__messages_out}"
;; ;;
absent) absent)
# use this because pkg_add doesn't properly handle errors # Use this because pkg_delete doesn't properly handle errors
cat << eof cat << EOF
status=\$(pkg_delete "$pkgopts" "$pkgid") status=\$(pkg_delete ${pkgopts} '${pkgid}' || true)
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}" 2>/dev/null
if pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}' 2>/dev/null
then
# We found the package in the list of 'installed packages'.
# This would indicate that pkg_delete failed, send the output of pkg_delete
# We found the package in the list of 'installed packages'
# This would indicate that pkg_delete failed, send the output of pkg_delete
if [ \$? -eq 0 ]; then
if [ -z "\${status}" ]; then if [ -z "\${status}" ]; then
status="Failed to remove package, uncaught exception." status='Failed to remove package, uncaught exception.'
fi fi
echo "Error: \$status" >&2 echo "Error: \${status}" >&2
exit 1 exit 1
fi fi
eof EOF
echo 'removed' >> "${__messages_out}"
;; ;;
*) *)
echo "Unknown state: $state_should" >&2 echo "Unknown state: ${state_should}" >&2
exit 1 exit 1
;; ;;
esac esac